// Included verbatim from UserCode/scasasso/HZZ4lAnalysis/HZZ4lCommon/src tag V00-00-00


/***************************************************************************** 
 * Project: RooFit                                                           * 
 *                                                                           * 
 * This code was autogenerated by RooClassFactory                            * 
 *****************************************************************************/ 

// Your description goes here... 

#include <math.h> 
#include "RooqqZZ_JHU.h"
#include "Riostream.h" 
#include "RooAbsReal.h" 
#include "RooAbsCategory.h" 
#include "TMath.h" 

//ClassImp(RooqqZZ_JHU) 

RooqqZZ_JHU::RooqqZZ_JHU(const char *name, const char *title, 
                         RooAbsReal& _m1j,
                         RooAbsReal& _m2j,
                         RooAbsReal& _h1j,
                         RooAbsReal& _h2j,
                         RooAbsReal& _phij,
                         RooAbsReal& _hsj,
                         RooAbsReal& _Phi1j,
                         RooAbsReal& _mZZj) :
RooAbsPdf(name,title), 
m1j("m1j","m1j",this,_m1j),
m2j("m2j","m2j",this,_m2j),
h1j("h1j","h1j",this,_h1j),
h2j("h2j","h2j",this,_h2j),
phij("phij","phij",this,_phij),
hsj("hsj","hsj",this,_hsj),
Phi1j("Phi1j","Phi1j",this,_Phi1j),
mZZj("mZZj","mZZj",this,_mZZj)
{ 
} 


RooqqZZ_JHU::RooqqZZ_JHU(const RooqqZZ_JHU& other, const char* name) :  
RooAbsPdf(other,name), 
m1j("m1j",this,other.m1j),
m2j("m2j",this,other.m2j),
h1j("h1j",this,other.h1j),
h2j("h2j",this,other.h2j),
phij("phij",this,other.phij),
hsj("hsj",this,other.hsj),
Phi1j("Phi1j",this,other.Phi1j),
mZZj("mZZj",this,other.mZZj)
{ 
} 



Double_t RooqqZZ_JHU::evaluate() const 
{ 
    // Do transformation of the angles from JHU to NW conventions...
    
    
    double m1_c = m1j;
    double m2_c = m2j;
    double h1_c = h1j;
    double h2_c = h2j;
    double phi_c = phij;
    double hs_c = hsj;
    double Phi1_c = Phi1j;
    double mZZ_c = mZZj;
    
    // ENTER EXPRESSION IN TERMS OF VARIABLE ARGUMENTS HERE 
    double up_plusZ = partonicXS(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
    double up_minusZ = partonicXS(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
    double down_plusZ = partonicXS(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
    double down_minusZ = partonicXS(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);
    
    //std::cout << "up_plusZ = " << up_plusZ << ", up_minusZ = " << up_minusZ << ", down_plusZ = " << down_plusZ << ", down_minusZ = " << down_minusZ << std::endl;
    
    double upfrac = 0.5;
    double downfrac = 0.5;
    
    //up_minusZ = 0; down_minusZ = 0;
    
    double totalxs = upfrac*(up_plusZ + up_minusZ) + downfrac*(down_plusZ + down_minusZ);
    
    double jacobian = 1./(mZZj*mZZj);
    return jacobian*totalxs ; 
} 


Int_t RooqqZZ_JHU::getAnalyticalIntegral(RooArgSet& allVars, RooArgSet& analVars, const char* /*rangeName*/) const
{
    
    // these are the variables you integrated out! 
    if (matchArgs(allVars,analVars,h1j,h2j,phij,Phi1j)) return 5 ;
    if (matchArgs(allVars,analVars,h2j,phij,Phi1j)) return 1 ;
    if (matchArgs(allVars,analVars,h1j,phij,Phi1j)) return 2 ;
    if (matchArgs(allVars,analVars,h1j,h2j,phij)) return 3 ;
    if (matchArgs(allVars,analVars,h1j,h2j,Phi1j)) return 4 ;
    return 0 ;
    
}
Double_t RooqqZZ_JHU::analyticalIntegral(Int_t code, const char* rangeName) const
{
    
    double m1_c = m1j;
    double m2_c = m2j;
    double h1_c = h1j;
    double h2_c = h2j;
    double phi_c = phij;
    double hs_c = hsj;
    double Phi1_c = Phi1j;
    double mZZ_c = mZZj;
    
    
    switch(code)
    {
            
        case 1:
        {
            double up_plusZ = integratePartonicXS_Dh2DphDPh1_1(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
            double up_minusZ = integratePartonicXS_Dh2DphDPh1_1(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
            double down_plusZ = integratePartonicXS_Dh2DphDPh1_1(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
            double down_minusZ = integratePartonicXS_Dh2DphDPh1_1(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);
            
            double upfrac = 0.5;
            double downfrac = 0.5;
            
            //up_minusZ = 0; down_minusZ = 0;
            
            double totalxs = upfrac*(up_plusZ + up_minusZ) + downfrac*(down_plusZ + down_minusZ);
            //std::cout << "case 1: up_plusZ = " << up_plusZ << ", up_minusZ = " << up_minusZ << ", down_plusZ = " << down_plusZ << ", down_minusZ = " << down_minusZ << std::endl;
            
            double jacobian = 1./(mZZj*mZZj);
            return jacobian*totalxs ; 
        }
        case 2:
        {
            double up_plusZ = integratePartonicXS_Dh1DphDPh1_2(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
            double up_minusZ = integratePartonicXS_Dh1DphDPh1_2(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
            double down_plusZ = integratePartonicXS_Dh1DphDPh1_2(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
            double down_minusZ = integratePartonicXS_Dh1DphDPh1_2(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);
            
            double upfrac = 0.5;
            double downfrac = 0.5;
            
            //up_minusZ = 0; down_minusZ = 0;
            
            double totalxs = upfrac*(up_plusZ + up_minusZ) + downfrac*(down_plusZ + down_minusZ);
            //std::cout << "case 2: up_plusZ = " << up_plusZ << ", up_minusZ = " << up_minusZ << ", down_plusZ = " << down_plusZ << ", down_minusZ = " << down_minusZ << std::endl;
            
            double jacobian = 1./(mZZj*mZZj);
            return jacobian*totalxs ; 
        }
        case 3:
        {
            double up_plusZ = integratePartonicXS_Dh1Dh2Dph_3(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
            double up_minusZ = integratePartonicXS_Dh1Dh2Dph_3(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
            double down_plusZ = integratePartonicXS_Dh1Dh2Dph_3(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
            double down_minusZ = integratePartonicXS_Dh1Dh2Dph_3(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);
            
            double upfrac = 0.5;
            double downfrac = 0.5;
            
            //up_minusZ = 0; down_minusZ = 0;
            
            double totalxs = upfrac*(up_plusZ + up_minusZ) + downfrac*(down_plusZ + down_minusZ);
            //std::cout << "case 3: up_plusZ = " << up_plusZ << ", up_minusZ = " << up_minusZ << ", down_plusZ = " << down_plusZ << ", down_minusZ = " << down_minusZ << std::endl;
            
            double jacobian = 1./(mZZj*mZZj);
            return jacobian*totalxs ; 
        }
        case 4:
        {
            double up_plusZ = integratePartonicXS_Dh1Dh2DPh1_4(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
            double up_minusZ = integratePartonicXS_Dh1Dh2DPh1_4(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
            double down_plusZ = integratePartonicXS_Dh1Dh2DPh1_4(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
            double down_minusZ = integratePartonicXS_Dh1Dh2DPh1_4(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);
            
            double upfrac = 0.5;
            double downfrac = 0.5;
            
            //up_minusZ = 0; down_minusZ = 0;
            
            double totalxs = upfrac*(up_plusZ + up_minusZ) + downfrac*(down_plusZ + down_minusZ);
            //std::cout << "case 4: up_plusZ = " << up_plusZ << ", up_minusZ = " << up_minusZ << ", down_plusZ = " << down_plusZ << ", down_minusZ = " << down_minusZ << std::endl;
            
            double jacobian = 1./(mZZj*mZZj);
            return jacobian*totalxs ; 
        }
        case 5:
        {
            double up_plusZ = integratePartonicXS_Dh1Dh2DphDPh1_5(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, true);
            double up_minusZ = integratePartonicXS_Dh1Dh2DphDPh1_5(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, true, false);
            double down_plusZ = integratePartonicXS_Dh1Dh2DphDPh1_5(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, true);
            double down_minusZ = integratePartonicXS_Dh1Dh2DphDPh1_5(m1_c, m2_c, h1_c, h2_c, phi_c, hs_c, Phi1_c, mZZ_c, false, false);
            
            double upfrac = 0.5;
            double downfrac = 0.5;
            
            //up_minusZ = 0; down_minusZ = 0;
            
            double totalxs = upfrac*(up_plusZ + up_minusZ) + downfrac*(down_plusZ + down_minusZ);
            //std::cout << "case 5: up_plusZ = " << up_plusZ << ", up_minusZ = " << up_minusZ << ", down_plusZ = " << down_plusZ << ", down_minusZ = " << down_minusZ << std::endl;
            
            double jacobian = 1./(mZZj*mZZj);
            return jacobian*totalxs ; 
        }
            
    }
    assert(0) ;
    return 0 ;
}
//*/
// 45 terms
Double_t RooqqZZ_JHU::partonicXS(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool upType, bool flipAxis) const
{
    
    // define hs, h1, h2, phi1, phi2 for the NW angular conventions
    double s = mZZ_c*mZZ_c;
    double M1 = m1_c;
    double M2 = m2_c;
    double hs = hs_c;
    double h1 = h1_c;
    double h2 = h2_c;
    double phi = phi_c;
    double Phi1 = Phi1_c;
    
    if (flipAxis){
        hs *= -1.;
        Phi1 += TMath::Pi();
        //phi += 0;
    }
    
    // extra definitions needed
    double shs = Sqrt(1-hs*hs); // sin Theta
    double sh1 = Sqrt(1-h1*h1); // sin theta1
    double sh2 = Sqrt(1-h2*h2); // sin theta2
    double hsdb = 1 - 2*shs*shs; // cos 2*Theta
    double shsdb = 2*hs*shs; // sin 2*Theta
    double h1db = 1 - 2*sh1*sh1; // cos 2*theta1
    double h2db = 1 - 2*sh2*sh2; // cos 2*theta2
    
    double x = (M1*M1-M2*M2)/s;
    double beta1 = Sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x))); 
    double beta2 = Sqrt(1. - (4.*M2*M2)/(s*(1+x)*(1+x)));
    double MZ = 91.18; // mass of the Z
    double gamma = 2.475; // width of the Z
    double xW = 0.2312; // sin2thetaW
    double Pi = TMath::Pi();
    double alpha = 1./137; // EM constant
    
    double Tf3 = -1/2.; double Qf = -1.;
    double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
    
    double qTf3, qQf;
    if (upType){
        qTf3 = 1/2.; qQf = 2./3.;
    }
    else{
        qTf3 = -1/2.; qQf = -1./3.;
    }
    double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
    
    // ----
    const int nterms = 45;
    double term[nterms];
    
    term[0] = (Power(alpha,4)*beta1*Power(M1,2)*Power(M2,2)*(1 + x)*(Power(gqL,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + Power(gqR,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*(4*(gL - gR)*(gL + gR)*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*(4*(gL - gR)*(gL + gR)*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*Power(shs,2))/(1.572864e6*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[1] = (Power(alpha,4)*beta1*Power(M1,2)*Power(M2,2)*(1 + x)*(Power(gqR,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + Power(gqL,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*(4*(-Power(gL,2) + Power(gR,2))*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*(4*(-Power(gL,2) + Power(gR,2))*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*Power(shs,2))/(1.572864e6*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[2] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*Power(M1,2)*Power(M2,2)*(1 + x)*(4*(-Power(gL,2) + Power(gR,2))*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*(4*(gL - gR)*(gL + gR)*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*Power(shs,2)*(Power(gqR,4)*Power(1 + hs,4) + Power(gqL,4)*Power(shs,4)))/(1.572864e6*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[3] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*Power(M1,2)*Power(M2,2)*(1 + x)*(4*(gL - gR)*(gL + gR)*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*(4*(-Power(gL,2) + Power(gR,2))*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*Power(shs,2)*(Power(gqL,4)*Power(1 + hs,4) + Power(gqR,4)*Power(shs,4)))/(1.572864e6*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[4] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1)*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(4*(gL - gR)*(gL + gR)*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*shs*(Power(gqR,4)*Power(1 + hs,2)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs) - Power(gqL,4)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,2))*sh1)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + x)*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[5] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1)*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(4*(gL - gR)*(gL + gR)*h2 - (Power(gL,2) + Power(gR,2))*(3 + h2db))*shs*(-(Power(gqL,4)*Power(1 + hs,2)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)) + Power(gqR,4)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,2))*sh1)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + x)*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[6] = -(Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(1 + beta1*beta2)*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1)*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(4*(gL - gR)*(gL + gR)*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*shs*(-(Power(gqR,4)*Power(1 + hs,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)) + Power(gqL,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,4))*sh1)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(1 - x)*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[7] = -(Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(1 + beta1*beta2)*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1)*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(4*(gL - gR)*(gL + gR)*h2 - (Power(gL,2) + Power(gR,2))*(3 + h2db))*shs*(Power(gqL,4)*Power(1 + hs,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs) - Power(gqR,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,4))*sh1)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(1 - x)*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[8] = (Power(alpha,4)*beta1*(1 + beta1*beta2)*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(2*(-Phi1 + Pi))*(4*(gL - gR)*(gL + gR)*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*Power(shs,2)*(Power(gqR,4)*Power(1 + hs,2)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs) + Power(gqL,4)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*Power(shs,2))*Power(sh1,2))/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[9] = (Power(alpha,4)*beta1*(1 + beta1*beta2)*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(2*(-Phi1 + Pi))*(4*(gL - gR)*(gL + gR)*h2 - (Power(gL,2) + Power(gR,2))*(3 + h2db))*Power(shs,2)*(-(Power(gqL,4)*Power(1 + hs,2)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)) - Power(gqR,4)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*Power(shs,2))*Power(sh1,2))/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[10] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*(4*(gL - gR)*(gL + gR)*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*(Power(gqR,4)*Power(1 + hs,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*Power(shs,4))*Power(sh1,2))/(3.145728e6*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + x,2)*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[11] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*(4*(-Power(gL,2) + Power(gR,2))*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*(Power(gqL,4)*Power(1 + hs,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*Power(shs,4))*Power(sh1,2))/(3.145728e6*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + x,2)*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[12] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta2,2))*Power(M1,2)*Power(M2,2)*Cos(phi + Phi1)*(4*(gL - gR)*(gL + gR)*h1 - (Power(gL,2) + Power(gR,2))*(3 + h1db))*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*shs*(Power(gqR,4)*Power(1 + hs,2)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs) - Power(gqL,4)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,2))*sh2)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[13] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta2,2))*Power(M1,2)*Power(M2,2)*Cos(phi + Phi1)*(4*(gL - gR)*(gL + gR)*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*shs*(-(Power(gqL,4)*Power(1 + hs,2)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs)) + Power(gqR,4)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,2))*sh2)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[14] = (Power(alpha,4)*beta1*(1 + beta1*beta2)*Sqrt(1 - Power(beta2,2))*Power(M1,2)*Power(M2,2)*Cos(phi + Phi1)*(4*(gL - gR)*(gL + gR)*h1 - (Power(gL,2) + Power(gR,2))*(3 + h1db))*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*shs*(Power(gqR,4)*Power(1 + hs,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs) - Power(gqL,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,4))*sh2)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[15] = (Power(alpha,4)*beta1*(1 + beta1*beta2)*Sqrt(1 - Power(beta2,2))*Power(M1,2)*Power(M2,2)*Cos(phi + Phi1)*(4*(gL - gR)*(gL + gR)*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*shs*(-(Power(gqL,4)*Power(1 + hs,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs)) + Power(gqR,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,4))*sh2)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[16] = -(Power(alpha,4)*beta1*Power(M1,2)*Power(M2,2)*(1 + x)*((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*Cos(phi)*hs*((1 + beta1*beta2)*(Power(gqL,4) - Power(gqR,4))*x - (-1 + beta1*beta2)*(Power(gqL,4) + Power(gqR,4))*hs)*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*Power(shs,2)*sh1*sh2)/(49152.*Sqrt((-1 + Power(beta1,2))*(-1 + Power(beta2,2)))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(1 - Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[17] = -(Power(alpha,4)*beta1*Power(M1,2)*Power(M2,2)*(1 + x)*((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*Cos(phi)*hs*((1 + beta1*beta2)*(-Power(gqL,4) + Power(gqR,4))*x - (-1 + beta1*beta2)*(Power(gqL,4) + Power(gqR,4))*hs)*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*Power(shs,2)*sh1*sh2)/(49152.*Sqrt((-1 + Power(beta1,2))*(-1 + Power(beta2,2)))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(1 - Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[18] = -(Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*Sqrt(1 - Power(beta2,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(phi + 2*Phi1)*(Power(gqL,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs) + Power(gqR,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs))*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*Power(shs,2)*sh1*sh2)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(1 - Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[19] = -(Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*Sqrt(1 - Power(beta2,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(phi + 2*Phi1)*(Power(gqR,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs) + Power(gqL,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs))*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*Power(shs,2)*sh1*sh2)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(1 - Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[20] = (Power(alpha,4)*beta1*(1 + beta1*beta2)*Power(M1,2)*Power(M2,2)*(1 + x)*((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*Cos(phi + 2*Phi1)*hs*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*Power(shs,2)*(Power(gqR,4)*Power(1 + hs,2) - Power(gqL,4)*Power(shs,2))*sh1*sh2)/(49152.*Sqrt((-1 + Power(beta1,2))*(-1 + Power(beta2,2)))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[21] = (Power(alpha,4)*beta1*(1 + beta1*beta2)*Power(M1,2)*Power(M2,2)*(1 + x)*((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*Cos(phi + 2*Phi1)*hs*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*Power(shs,2)*(Power(gqL,4)*Power(1 + hs,2) - Power(gqR,4)*Power(shs,2))*sh1*sh2)/(49152.*Sqrt((-1 + Power(beta1,2))*(-1 + Power(beta2,2)))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[22] = -(Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*Sqrt(1 - Power(beta2,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(phi)*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*(Power(gqR,4)*Power(1 + hs,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs) + Power(gqL,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,4))*sh1*sh2)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(1 - Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[23] = -(Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*Sqrt(1 - Power(beta2,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(phi)*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*(Power(gqL,4)*Power(1 + hs,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs) + Power(gqR,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,4))*sh1*sh2)/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(1 - Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[24] = (Power(alpha,4)*beta1*(1 + beta1*beta2)*Sqrt(1 - Power(beta2,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*Cos(phi + Phi1 - 2*(-Phi1 + Pi))*((-Power(gqL,4) + Power(gqR,4))*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2)) + 4*(Power(gqL,4) + Power(gqR,4))*(1 + x)*hs)*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*Power(shs,3)*Power(sh1,2)*sh2)/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*Power(-1 - Power(beta1,2)*Power(beta2,2) + Power(x + beta1*beta2*x,2) + 2*beta1*beta2*hsdb,2));
    
    term[25] = (Power(alpha,4)*beta1*(1 + beta1*beta2)*Sqrt(1 - Power(beta2,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*Cos(phi + Phi1 - 2*(-Phi1 + Pi))*((Power(gqL,4) - Power(gqR,4))*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2)) + 4*(Power(gqL,4) + Power(gqR,4))*(1 + x)*hs)*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*Power(shs,3)*Power(sh1,2)*sh2)/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*Power(-1 - Power(beta1,2)*Power(beta2,2) + Power(x + beta1*beta2*x,2) + 2*beta1*beta2*hsdb,2));
    
    term[26] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*Cos(phi + Phi1)*hs*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*shs*(-(Power(gqR,4)*Power(1 + hs,2)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)) - Power(gqL,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,2))*Power(sh1,2)*sh2)/(98304.*Sqrt((-1 + Power(beta1,2))*(-1 + Power(beta2,2)))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + x)*(-1 + Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[27] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*Cos(phi + Phi1)*hs*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*shs*(-(Power(gqL,4)*Power(1 + hs,2)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)) - Power(gqR,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,2))*Power(sh1,2)*sh2)/(98304.*Sqrt((-1 + Power(beta1,2))*(-1 + Power(beta2,2)))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + x)*(-1 + Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[28] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta2,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*Cos(phi + Phi1 + 2*(-Phi1 + Pi))*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*shs*(Power(gqR,4)*Power(1 + hs,2)*(-((1 + beta1*beta2)*x) + (1 - beta1*beta2)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs) + Power(gqL,4)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,2))*Power(sh1,2)*sh2)/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[29] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta2,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*Cos(phi + Phi1 + 2*(-Phi1 + Pi))*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h2)*shs*(Power(gqL,4)*Power(1 + hs,2)*(-((1 + beta1*beta2)*x) + (1 - beta1*beta2)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs) + Power(gqR,4)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,2))*Power(sh1,2)*sh2)/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[30] = (Power(alpha,4)*beta1*(1 + beta1*beta2)*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(2*(phi + Phi1))*(4*(gL - gR)*(gL + gR)*h1 - (Power(gL,2) + Power(gR,2))*(3 + h1db))*Power(shs,2)*(Power(gqR,4)*Power(1 + hs,2)*(x + beta1*beta2*x + hs - beta1*beta2*hs) + Power(gqL,4)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*Power(shs,2))*Power(sh2,2))/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[31] = (Power(alpha,4)*beta1*(1 + beta1*beta2)*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(2*(phi + Phi1))*(4*(gL - gR)*(gL + gR)*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*Power(shs,2)*(-(Power(gqL,4)*Power(1 + hs,2)*(x + beta1*beta2*x + hs - beta1*beta2*hs)) - Power(gqR,4)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*Power(shs,2))*Power(sh2,2))/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[32] = (Power(alpha,4)*beta1*(1 - Power(beta2,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(4*(-Power(gL,2) + Power(gR,2))*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*(Power(gqR,4)*Power(1 + hs,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*Power(shs,4))*Power(sh2,2))/(3.145728e6*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(1 + x)*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[33] = (Power(alpha,4)*beta1*(1 - Power(beta2,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(4*(gL - gR)*(gL + gR)*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*(Power(gqL,4)*Power(1 + hs,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*Power(shs,4))*Power(sh2,2))/(3.145728e6*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(1 + x)*Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[34] = -(Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(1 + beta1*beta2)*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1 + 2*(phi + Phi1))*((-Power(gqL,4) + Power(gqR,4))*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2)) + 4*(Power(gqL,4) + Power(gqR,4))*(-1 + x)*hs)*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*Power(shs,3)*sh1*Power(sh2,2))/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + x)*Power(-1 + xW,4)*Power(xW,4)*Power(-1 - Power(beta1,2)*Power(beta2,2) + Power(x + beta1*beta2*x,2) + 2*beta1*beta2*hsdb,2));
    
    term[35] = -(Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(1 + beta1*beta2)*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1 + 2*(phi + Phi1))*((Power(gqL,4) - Power(gqR,4))*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2)) + 4*(Power(gqL,4) + Power(gqR,4))*(-1 + x)*hs)*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*Power(shs,3)*sh1*Power(sh2,2))/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + x)*Power(-1 + xW,4)*Power(xW,4)*Power(-1 - Power(beta1,2)*Power(beta2,2) + Power(x + beta1*beta2*x,2) + 2*beta1*beta2*hsdb,2));
    
    term[36] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta2,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*Cos(Phi1)*hs*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*shs*(-(Power(gqR,4)*Power(1 + hs,2)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs)) - Power(gqL,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,2))*sh1*Power(sh2,2))/(98304.*Sqrt((-1 + Power(beta1,2))*(-1 + Power(beta2,2)))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[37] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta2,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*Cos(Phi1)*hs*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*shs*(-(Power(gqL,4)*Power(1 + hs,2)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs)) - Power(gqR,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,2))*sh1*Power(sh2,2))/(98304.*Sqrt((-1 + Power(beta1,2))*(-1 + Power(beta2,2)))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + Power(x,2))*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[38] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1 - 2*(phi + Phi1))*(-Power(gL,2) + Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*shs*(Power(gqR,4)*Power(1 + hs,2)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs) - Power(gqL,4)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,2))*sh1*Power(sh2,2))/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + x)*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[39] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1 - 2*(phi + Phi1))*(Power(gL,2) - Power(gR,2) + (Power(gL,2) + Power(gR,2))*h1)*shs*(Power(gqL,4)*Power(1 + hs,2)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs) - Power(gqR,4)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,2))*sh1*Power(sh2,2))/(393216.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(-1 + x)*Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    term[40] = -(Power(alpha,4)*beta1*(Power(gqL,4) + Power(gqR,4))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(2*(phi + Pi))*(x + beta1*beta2*x + hs - beta1*beta2*hs)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*Power(shs,2)*Power(sh1,2)*Power(sh2,2))/(196608.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*Power(-1 - Power(beta1,2)*Power(beta2,2) + Power(x + beta1*beta2*x,2) + 2*beta1*beta2*hsdb,2));
    
    term[41] = (Power(alpha,4)*beta1*(-1 + Power(beta2,2))*(Power(gqL,4) + Power(gqR,4))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*Cos(2*(-Phi1 + Pi))*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,2)*Power(sh1,2)*Power(sh2,2))/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*(1 + x)*Power(-1 + xW,4)*Power(xW,4)*Power(-1 - Power(beta1,2)*Power(beta2,2) + Power(x + beta1*beta2*x,2) + 2*beta1*beta2*hsdb,2));
    
    term[42] = (Power(alpha,4)*beta1*(-1 + Power(beta1,2))*(Power(gqL,4) + Power(gqR,4))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(2*(phi + Phi1))*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)*Power(shs,2)*Power(sh1,2)*Power(sh2,2))/(786432.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + x,2)*Power(-1 + xW,4)*Power(xW,4)*Power(-1 - Power(beta1,2)*Power(beta2,2) + Power(x + beta1*beta2*x,2) + 2*beta1*beta2*hsdb,2));
    
    term[43] = -(Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*(Power(gqL,4) + Power(gqR,4))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(2*(-phi - 2*Phi1 + Pi))*Power(shs,4)*Power(sh1,2)*Power(sh2,2))/(196608.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + xW,4)*Power(xW,4)*Power(-1 - Power(beta1,2)*Power(beta2,2) + Power(x + beta1*beta2*x,2) + 2*beta1*beta2*hsdb,2));
    
    term[44] = (Power(alpha,4)*beta1*(Power(gqL,4) + Power(gqR,4))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*(1 + x)*Power((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)),2)*Power(shsdb,2)*Power(sh1,2)*Power(sh2,2))/(98304.*(-1 + Power(beta1,2))*(-1 + Power(beta2,2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*(Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,3)*s*Power(-1 + Power(x,2),2)*Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2));
    
    double returnVal = 0.; 
    for (int i = 0; i < nterms; i++){
        //std::cout << "term[" << i << "] = " << term[i] << std::endl;
        if (term[i] != term[i]) { 
	    std::cout << "term[" << i << "] isNaN" << std::endl; 
            term[i] = 0.; 
        }
        returnVal += term[i];
    }
    
    if (returnVal <= 0) returnVal = 1.e-40;
    
    //std::cout << "returnVal = " << returnVal << std::endl;
    
    return returnVal;
    
}

Double_t RooqqZZ_JHU::integratePartonicXS_Dh2DphDPh1_1(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool upType, bool flipAxis) const
{
    
    // define hs, h1, h2, phi1, phi2 for the NW angular conventions
    double s = mZZ_c*mZZ_c;
    double M1 = m1_c;
    double M2 = m2_c;
    double hs = hs_c;
    double h1 = h1_c;
    //double h2 = h2_c;
    //double phi = phi_c; NOT USED!!
    double Phi1 = Phi1_c;
    
    if (flipAxis){
        hs *= -1.;
        Phi1 += TMath::Pi();
        //phi += 0;
    }
    
    // extra definitions needed
    double shs = Sqrt(1-hs*hs); // sin Theta
    double sh1 = Sqrt(1-h1*h1); // sin theta1
    //double sh2 = Sqrt(1-h2*h2); // sin theta2
    //double hsdb = 1 - 2*shs*shs; // cos 2*Theta  NOT USED!!
    double shsdb = 2*hs*shs; // sin 2*Theta
    double h1db = 1 - 2*sh1*sh1; // cos 2*theta1
    //double h2db = 1 - 2*sh2*sh2; // cos 2*theta2 NOT USED!!
    
    double x = (M1*M1-M2*M2)/s;
    double beta1 = Sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x))); 
    double beta2 = Sqrt(1. - (4.*M2*M2)/(s*(1+x)*(1+x)));
    double MZ = 91.18; // mass of the Z
    double gamma = 2.475; // width of the Z
    double xW = 0.2312; // sin2thetaW
    double Pi = TMath::Pi();
    double alpha = 1./137; // EM constant
    
    double Tf3 = -1/2.; double Qf = -1.;
    double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
    
    double qTf3, qQf;
    if (upType){
        qTf3 = 1/2.; qQf = 2./3.;
    }
    else{
        qTf3 = -1/2.; qQf = -1./3.;
    }
    double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
    
    // ----
    const int nterms = 9;
    double term[nterms];
    
    
    term[0] = (Power(alpha,4)*beta1*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*
               (Power(gqL,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + 
                Power(gqR,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*
               (4*(gL - gR)*(gL + gR)*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*
               Power(shs,2))/
    (73728.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                       4*beta1*beta2*Power(shs,2),2)) ;
    
    term[1] = (Power(alpha,4)*beta1*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*
               (Power(gqR,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + 
                Power(gqL,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*
               (4*(-Power(gL,2) + Power(gR,2))*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*
               Power(shs,2))/
    (73728.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                       4*beta1*beta2*Power(shs,2),2)) ;
    
    term[2] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*
               (1 + x)*(4*(-Power(gL,2) + Power(gR,2))*h1 + 
                        (Power(gL,2) + Power(gR,2))*(3 + h1db))*Power(shs,2)*
               (Power(gqR,4)*Power(1 + hs,4) + Power(gqL,4)*Power(shs,4)))/
    (73728.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[3] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*
               (1 + x)*(4*(gL - gR)*(gL + gR)*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*
               Power(shs,2)*(Power(gqL,4)*Power(1 + hs,4) + Power(gqR,4)*Power(shs,4)))/
    (73728.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[4] = (Power(alpha,4)*beta1*(1 - Power(beta2,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*
               (4*(-Power(gL,2) + Power(gR,2))*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*
               (Power(gqR,4)*Power(1 + hs,4)*
                Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                      (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + 
                Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*
                Power(shs,4)))/
    (589824.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(1 + x)*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[5] = (Power(alpha,4)*beta1*(1 - Power(beta2,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*
               (4*(gL - gR)*(gL + gR)*h1 + (Power(gL,2) + Power(gR,2))*(3 + h1db))*
               (Power(gqL,4)*Power(1 + hs,4)*
                Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                      (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + 
                Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*
                Power(shs,4)))/
    (589824.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(1 + x)*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)); 
    
    term[6] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*
               (1 + x)*(Power(gqR,4)*Power(1 + hs,4)*
                        Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                              (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + 
                        Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                           (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*
                        Power(shs,4))*Power(sh1,2))/
    (147456.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + x,2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)) ;
    
    term[7] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
               Power(M2,2)*(1 + x)*(Power(gqL,4)*Power(1 + hs,4)*
                                    Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                          (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + 
                                    Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                                       (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*
                                    Power(shs,4))*Power(sh1,2))/
    (147456.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + x,2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)) ;
    
    term[8] = (Power(alpha,4)*beta1*(Power(gqL,4) + Power(gqR,4))*Power(Power(gL,2) + Power(gR,2),2)*
               Power(M1,2)*Power(M2,2)*(1 + x)*Power((beta1 + beta2 - beta1*x + beta2*x)*
                                                     Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)),2)*
               Power(shsdb,2)*Power(sh1,2))/
    (18432.*(-1 + Power(beta1,2))*(-1 + Power(beta2,2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + Power(x,2),2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                        4*beta1*beta2*Power(shs,2),2));
    
    
    double returnVal = 0.; 
    for (int i = 0; i < nterms; i++){
        //std::cout << "term[" << i << "] = " << term[i] << std::endl;
        if (term[i] != term[i]) { 
            //std::cout << "isNaN" << std::endl; 
            term[i] = 0.; 
        }
        returnVal += term[i];
    }
    
    if (returnVal <= 0) returnVal = 1.e-40;
    return returnVal;
    
}

Double_t RooqqZZ_JHU::integratePartonicXS_Dh1DphDPh1_2(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool upType, bool flipAxis) const
{
    // define hs, h1, h2, phi1, phi2 for the NW angular conventions
    double s = mZZ_c*mZZ_c;
    double M1 = m1_c;
    double M2 = m2_c;
    double hs = hs_c;
    //double h1 = h1_c;
    double h2 = h2_c;
    //double phi = phi_c; NOT USED !!
    double Phi1 = Phi1_c;
    
    if (flipAxis){
        hs *= -1.;
        Phi1 += TMath::Pi();
        //phi += 0;
    }
    
    // extra definitions needed
    double shs = Sqrt(1-hs*hs); // sin Theta
    //double sh1 = Sqrt(1-h1*h1); // sin theta1
    double sh2 = Sqrt(1-h2*h2); // sin theta2
    //double hsdb = 1 - 2*shs*shs; // cos 2*Theta  NOT USED
    double shsdb = 2*hs*shs; // sin 2*Theta
    //double h1db = 1 - 2*sh1*sh1; // cos 2*theta1 NOT USED
    double h2db = 1 - 2*sh2*sh2; // cos 2*theta2
    
    double x = (M1*M1-M2*M2)/s;
    double beta1 = Sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x))); 
    double beta2 = Sqrt(1. - (4.*M2*M2)/(s*(1+x)*(1+x)));
    double MZ = 91.18; // mass of the Z
    double gamma = 2.475; // width of the Z
    double xW = 0.2312; // sin2thetaW
    double Pi = TMath::Pi();
    double alpha = 1./137; // EM constant
    
    double Tf3 = -1/2.; double Qf = -1.;
    double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
    
    double qTf3, qQf;
    if (upType){
        qTf3 = 1/2.; qQf = 2./3.;
    }
    else{
        qTf3 = -1/2.; qQf = -1./3.;
    }
    double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
    
    const int nterms = 9;
    double term[nterms];
    
    term[0] = (Power(alpha,4)*beta1*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*
               (Power(gqL,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + 
                Power(gqR,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*
               (4*(gL - gR)*(gL + gR)*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*
               Power(shs,2))/
    (73728.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                       4*beta1*beta2*Power(shs,2),2)) ;
    
    term[1] = (Power(alpha,4)*beta1*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*
               (Power(gqR,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + 
                Power(gqL,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*
               (4*(-Power(gL,2) + Power(gR,2))*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*
               Power(shs,2))/
    (73728.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                       4*beta1*beta2*Power(shs,2),2)) ;
    
    term[2] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*
               (1 + x)*(4*(gL - gR)*(gL + gR)*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*
               Power(shs,2)*(Power(gqR,4)*Power(1 + hs,4) + Power(gqL,4)*Power(shs,4)))/
    (73728.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[3] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*
               (1 + x)*(4*(-Power(gL,2) + Power(gR,2))*h2 + 
                        (Power(gL,2) + Power(gR,2))*(3 + h2db))*Power(shs,2)*
               (Power(gqL,4)*Power(1 + hs,4) + Power(gqR,4)*Power(shs,4)))/
    (73728.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[4] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*
               (1 + x)*(4*(gL - gR)*(gL + gR)*h2 + (Power(gL,2) + Power(gR,2))*(3 + h2db))*
               (Power(gqR,4)*Power(1 + hs,4)*
                Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                      (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + 
                Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*
                Power(shs,4)))/
    (589824.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + x,2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)) ;
    
    term[5] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*
               (1 + x)*(4*(-Power(gL,2) + Power(gR,2))*h2 + 
                        (Power(gL,2) + Power(gR,2))*(3 + h2db))*
               (Power(gqL,4)*Power(1 + hs,4)*
                Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                      (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + 
                Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*
                Power(shs,4)))/
    (589824.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + x,2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)) ;
    
    term[6] = (Power(alpha,4)*beta1*(1 - Power(beta2,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
               Power(M2,2)*(Power(gqR,4)*Power(1 + hs,4)*
                            Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                  (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + 
                            Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                               (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*
                            Power(shs,4))*Power(sh2,2))/
    (147456.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(1 + x)*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[7] = (Power(alpha,4)*beta1*(1 - Power(beta2,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*
               (Power(gqL,4)*Power(1 + hs,4)*
                Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                      (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + 
                Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*
                Power(shs,4))*Power(sh2,2))/
    (147456.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(1 + x)*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[8] = (Power(alpha,4)*beta1*(Power(gqL,4) + Power(gqR,4))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
               Power(M2,2)*(1 + x)*Power((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + 
                                         (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)),2)*Power(shsdb,2)*
               Power(sh2,2))/
    (18432.*(-1 + Power(beta1,2))*(-1 + Power(beta2,2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + Power(x,2),2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                        4*beta1*beta2*Power(shs,2),2));
    
    double returnVal = 0.; 
    for (int i = 0; i < nterms; i++){
        //std::cout << "term[" << i << "] = " << term[i] << std::endl;
        if (term[i] != term[i]) { 
            //std::cout << "isNaN" << std::endl; 
            term[i] = 0.; 
        }
        returnVal += term[i];
    }
    
    if (returnVal <= 0) returnVal = 1.e-40;    
    return returnVal;
    
}

Double_t RooqqZZ_JHU::integratePartonicXS_Dh1Dh2Dph_3(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool upType, bool flipAxis) const
{
    // define hs, h1, h2, phi1, phi2 for the NW angular conventions
    double s = mZZ_c*mZZ_c;
    double M1 = m1_c;
    double M2 = m2_c;
    double hs = hs_c;
    // double h1 = h1_c;
    // double h2 = h2_c;
    //double phi = phi_c; NOT USED !!
    double Phi1 = Phi1_c;
    
    if (flipAxis){
        hs *= -1.;
        Phi1 += TMath::Pi();
        //phi += 0;
    }
    
    /*
    std::cout << "-----------" << std::endl;
    std::cout << "h1 = " << h1 << "; " << std::endl;
    std::cout << "h2 = " << h2 << "; " << std::endl;
    std::cout << "hs = " << hs << "; " << std::endl;
    std::cout << "phi = " << phi << "; " << std::endl;
    std::cout << "Phi1 = " << Phi1 << "; " << std::endl;
    //*/
    
    // extra definitions needed
    double shs = Sqrt(1-hs*hs); // sin Theta
    //double sh1 = Sqrt(1-h1*h1); // sin theta1
    //double sh2 = Sqrt(1-h2*h2); // sin theta2
    double hsdb = 1 - 2*shs*shs; // cos 2*Theta
    double shsdb = 2*hs*shs; // sin 2*Theta
    //double h1db = 1 - 2*sh1*sh1; // cos 2*theta1  NOT USED
    //double h2db = 1 - 2*sh2*sh2; // cos 2*theta2  NOT USED!!
    
    double x = (M1*M1-M2*M2)/s;
    double beta1 = Sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x))); 
    double beta2 = Sqrt(1. - (4.*M2*M2)/(s*(1+x)*(1+x)));
    double MZ = 91.18; // mass of the Z
    double gamma = 2.475; // width of the Z
    double xW = 0.2312; // sin2thetaW
    double Pi = TMath::Pi();
    double alpha = 1./137; // EM constant
    
    double Tf3 = -1/2.; double Qf = -1.;
    double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
    
    double qTf3, qQf;
    if (upType){
        qTf3 = 1/2.; qQf = 2./3.;
    }
    else{
        qTf3 = -1/2.; qQf = -1./3.;
    }
    double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
    
    /*
    std::cout << "-----------" << std::endl;
    std::cout << "beta1 = " << beta1 << "; " << std::endl;
    std::cout << "beta2 = " << beta2 << "; " << std::endl;
    std::cout << "gL = " << gL << "; " << std::endl;
    std::cout << "gR = " << gR << "; " << std::endl;
    std::cout << "gqL = " << gqL << "; " << std::endl;
    std::cout << "gqR = " << gqR << "; " << std::endl;    
    //*/
    
    const int nterms = 18;
    double term[nterms];
    
    /////////////////////////////
    term[0] = (Power(alpha,4)*beta1*(-1 + Power(beta2,2))*(Power(gqL,4) + Power(gqR,4))*
               Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*Cos(2*(-Phi1 + Pi))*
               (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs)*
               (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,2))/
    (221184.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*(1 + x)*
     Power(-1 + xW,4)*Power(xW,4)*Power(-1 - Power(beta1,2)*Power(beta2,2) + 
                                        Power(x + beta1*beta2*x,2) + 2*beta1*beta2*hsdb,2)) ;
    
    
    term[1] = (Power(alpha,4)*beta1*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*(1 + x)*
               (Power(gqR,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + 
                Power(gqL,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*Power(shs,2))/
    (27648.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                       4*beta1*beta2*Power(shs,2),2)) ;
    
    term[2] = (Power(alpha,4)*beta1*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*(1 + x)*
               (Power(gqL,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + 
                Power(gqR,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*Power(shs,2))/
    (27648.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                       4*beta1*beta2*Power(shs,2),2)) ;
    
    term[3] = (Power(alpha,4)*beta1*(1 + beta1*beta2)*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*
               (1 + x)*Cos(2*(-Phi1 + Pi))*Power(shs,2)*
               (Power(gqR,4)*Power(1 + hs,2)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs) + 
                Power(gqL,4)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*Power(shs,2)))/
    (27648.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + xW,4)*
     Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                        4*beta1*beta2*Power(shs,2),2)) ;
    
    term[4] = -(Power(alpha,4)*beta1*(1 + beta1*beta2)*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*
                (1 + x)*Cos(2*(-Phi1 + Pi))*Power(shs,2)*
                (-(Power(gqL,4)*Power(1 + hs,2)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)) - 
                 Power(gqR,4)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*Power(shs,2)))/
    (27648.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + xW,4)*
     Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                        4*beta1*beta2*Power(shs,2),2)) ;
    
    term[5] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(gL - gR)*(gL + gR)*(Power(gL,2) + Power(gR,2))*
               Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1)*shs*
               (Power(gqR,4)*Power(1 + hs,2)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*
                (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                 (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs) - 
                Power(gqL,4)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*
                (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                 (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,2)
                ))/(147456.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
                    (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(-1 + x)*Power(-1 + xW,4)*
                    Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                                       4*beta1*beta2*Power(shs,2),2)) ;
    
    term[6] = -(Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(-Power(gL,2) + Power(gR,2))*
                (Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1)*shs*
                (-(Power(gqL,4)*Power(1 + hs,2)*(x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*
                   (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                    (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)) + 
                 Power(gqR,4)*(x + beta1*beta2*x + hs - beta1*beta2*hs)*
                 (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                  (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,2)
                 ))/(147456.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
                     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(-1 + x)*Power(-1 + xW,4)*
                     Power(xW,4)*(1 + hs)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                                        4*beta1*beta2*Power(shs,2),2)) ;
    
    term[7] = (Power(alpha,4)*beta1*Sqrt((1 - Power(beta2,2))/((-1 + Power(beta1,2))*(-1 + Power(beta2,2))))*
               (-Power(gL,2) + Power(gR,2))*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*
               ((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + 
                (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*Cos(Phi1)*hs*shs*
               (-(Power(gqR,4)*Power(1 + hs,2)*
                  (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs)) - 
                Power(gqL,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                              (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,2))
               )/(73728.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
                  (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(-1 + Power(x,2))*
                  Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*
                  Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)) ;
    
    term[8] = (Power(alpha,4)*beta1*Sqrt((1 - Power(beta2,2))/((-1 + Power(beta1,2))*(-1 + Power(beta2,2))))*
               (gL - gR)*(gL + gR)*(Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*
               ((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + 
                (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*Cos(Phi1)*hs*shs*
               (-(Power(gqL,4)*Power(1 + hs,2)*
                  (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs)) - 
                Power(gqR,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                              (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,2))
               )/(73728.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
                  (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(-1 + Power(x,2))*
                  Power(-1 + xW,4)*Power(xW,4)*(1 + hs)*
                  Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)) ;
    
    term[9] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
               Power(M2,2)*(1 + x)*Power(shs,2)*
               (Power(gqR,4)*Power(1 + hs,4) + Power(gqL,4)*Power(shs,4)))/
    (27648.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[10] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
                Power(M2,2)*(1 + x)*Power(shs,2)*
                (Power(gqL,4)*Power(1 + hs,4) + Power(gqR,4)*Power(shs,4)))/
    (27648.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[11] = -(Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(1 + beta1*beta2)*(-Power(gL,2) + Power(gR,2))*
                 (Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1)*shs*
                 (-(Power(gqR,4)*Power(1 + hs,4)*
                    (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                     (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)) + 
                  Power(gqL,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,4)
                  ))/(147456.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
                      (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(1 - x)*Power(-1 + xW,4)*
                      Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                                                4*beta1*beta2*Power(shs,2),2)) ;
    
    term[12] = (Power(alpha,4)*beta1*Sqrt(1 - Power(beta1,2))*(1 + beta1*beta2)*(gL - gR)*(gL + gR)*
                (Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(Phi1)*shs*
                (Power(gqL,4)*Power(1 + hs,4)*
                 (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                  (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs) - 
                 Power(gqR,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                               (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*Power(shs,4)
                 ))/(147456.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
                     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(1 - x)*Power(-1 + xW,4)*
                     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[13] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*
                (1 + x)*(Power(gqR,4)*Power(1 + hs,4)*
                         Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                               (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + 
                         Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                            (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*
                         Power(shs,4)))/
    (221184.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + x,2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
     ) ;
    
    term[14] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
                Power(M2,2)*(1 + x)*(Power(gqL,4)*Power(1 + hs,4)*
                                     Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                           (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + 
                                     Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                                        (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*
                                     Power(shs,4)))/
    (221184.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + x,2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
     ) ;
    
    term[15] = (Power(alpha,4)*beta1*(1 - Power(beta2,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
                Power(M2,2)*(Power(gqR,4)*Power(1 + hs,4)*
                             Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + 
                             Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                                (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*
                             Power(shs,4)))/
    (221184.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*(1 + x)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
     ) ;
    
    term[16] = (Power(alpha,4)*beta1*(1 - Power(beta2,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
                Power(M2,2)*(Power(gqL,4)*Power(1 + hs,4)*
                             Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + 
                             Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                                (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*
                             Power(shs,4)))/
    (221184.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*(1 + x)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)) ;
    
    term[17] = (Power(alpha,4)*beta1*(Power(gqL,4) + Power(gqR,4))*Power(Power(gL,2) + Power(gR,2),2)*
                Power(M1,2)*Power(M2,2)*(1 + x)*Power((beta1 + beta2 - beta1*x + beta2*x)*
                                                      Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)),2)*
                Power(shsdb,2))/
    (27648.*(-1 + Power(beta1,2))*(-1 + Power(beta2,2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*
     Power(-1 + Power(x,2),2)*Power(-1 + xW,4)*Power(xW,4)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)) ;
    
    
    double returnVal = 0.; 
    //std::cout << "------" << std::endl;
    for (int i = 0; i < nterms; i++){
        //std::cout << "term[" << i << "] = " << term[i] << std::endl;
        if (term[i] != term[i]) { 
            //std::cout << "isNaN" << std::endl; 
            term[i] = 0.; 
        }
        returnVal += term[i];
    }
    
    if (returnVal <= 0) returnVal = 1.e-40;
    
    //std::cout << "returnVal = " << returnVal << std::endl;
    
    return returnVal;
    
}
Double_t RooqqZZ_JHU::integratePartonicXS_Dh1Dh2DPh1_4(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool upType, bool flipAxis) const
{
    // define hs, h1, h2, phi1, phi2 for the NW angular conventions
    double s = mZZ_c*mZZ_c;
    double M1 = m1_c;
    double M2 = m2_c;
    double hs = hs_c;
    //double h1 = h1_c;
    //double h2 = h2_c;
    double phi = phi_c;
    double Phi1 = Phi1_c;
    
    if (flipAxis){
        hs *= -1.;
        Phi1 += TMath::Pi();
        //phi += 0;
    }
    
    // extra definitions needed
    double shs = Sqrt(1-hs*hs); // sin Theta
    //double sh1 = Sqrt(1-h1*h1); // sin theta1
    //double sh2 = Sqrt(1-h2*h2); // sin theta2
    double hsdb = 1 - 2*shs*shs; // cos 2*Theta 
    double shsdb = 2*hs*shs; // sin 2*Theta
    //double h1db = 1 - 2*sh1*sh1; // cos 2*theta1 NOT USED
    //double h2db = 1 - 2*sh2*sh2; // cos 2*theta2  NOT USED
    
    double x = (M1*M1-M2*M2)/s;
    double beta1 = Sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x))); 
    double beta2 = Sqrt(1. - (4.*M2*M2)/(s*(1+x)*(1+x)));
    double MZ = 91.18; // mass of the Z
    double gamma = 2.475; // width of the Z
    double xW = 0.2312; // sin2thetaW
    double Pi = TMath::Pi();
    double alpha = 1./137; // EM constant
    
    double Tf3 = -1/2.; double Qf = -1.;
    double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
    
    double qTf3, qQf;
    if (upType){
        qTf3 = 1/2.; qQf = 2./3.;
    }
    else{
        qTf3 = -1/2.; qQf = -1./3.;
    }
    double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
    
    const int nterms = 14;
    double term[nterms];
    
    /////////////////////////////////
    term[0] = -(Power(alpha,4)*beta1*(Power(gqL,4) + Power(gqR,4))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
                Power(M2,2)*(1 + x)*Cos(2*(phi + Pi))*(x + beta1*beta2*x + hs - beta1*beta2*hs)*
                (x + beta1*beta2*x + (-1 + beta1*beta2)*hs)*Power(shs,2))/
    (55296.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(-1 - Power(beta1,2)*Power(beta2,2) + Power(x + beta1*beta2*x,2) + 
                       2*beta1*beta2*hsdb,2)) ;
    
    term[1] = - (Power(alpha,4)*beta1*Power(gL - gR,2)*Power(gL + gR,2)*
                 Power(M1,2)*Power(M2,2)*(1 + x)*((beta1 + beta2 - beta1*x + beta2*x)*
                                                  Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*
                 Cos(phi)*hs*((1 + beta1*beta2)*(Power(gqL,4) - Power(gqR,4))*x - 
                                      (-1 + beta1*beta2)*(Power(gqL,4) + Power(gqR,4))*hs)*Power(shs,2))/
    (98304.*Sqrt((-1 + Power(beta1,2))*(-1 + Power(beta2,2)))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*s*(1 - Power(x,2))*
     Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                        4*beta1*beta2*Power(shs,2),2)) ;
    
    term[2] = - (Power(alpha,4)*beta1*Power(-Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*(1 + x)*
                 ((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + 
                  (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)))*Cos(phi)*hs*
                 ((1 + beta1*beta2)*(-Power(gqL,4) + Power(gqR,4))*x - 
                  (-1 + beta1*beta2)*(Power(gqL,4) + Power(gqR,4))*hs)*Power(shs,2))/
    (98304.*Sqrt((-1 + Power(beta1,2))*(-1 + Power(beta2,2)))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*s*(1 - Power(x,2))*
     Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                        4*beta1*beta2*Power(shs,2),2)) ;
    
    term[3] = (Power(alpha,4)*beta1*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*(1 + x)*
               (Power(gqR,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + 
                Power(gqL,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*Power(shs,2))/
    (27648.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                       4*beta1*beta2*Power(shs,2),2)) ;
    
    term[4] = (Power(alpha,4)*beta1*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*(1 + x)*
               (Power(gqL,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + 
                Power(gqR,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*Power(shs,2))/
    (27648.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                       4*beta1*beta2*Power(shs,2),2)) ;
    
    term[5] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
               Power(M2,2)*(1 + x)*Power(shs,2)*
               (Power(gqR,4)*Power(1 + hs,4) + Power(gqL,4)*Power(shs,4)))/
    (27648.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[6] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
               Power(M2,2)*(1 + x)*Power(shs,2)*
               (Power(gqL,4)*Power(1 + hs,4) + Power(gqR,4)*Power(shs,4)))/
    (27648.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[7] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*
               (1 + x)*(Power(gqR,4)*Power(1 + hs,4)*
                        Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                              (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + 
                        Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                           (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*
                        Power(shs,4)))/
    (221184.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + x,2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
     ) ;
    
    term[8] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
               Power(M2,2)*(1 + x)*(Power(gqL,4)*Power(1 + hs,4)*
                                    Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                          (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + 
                                    Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                                       (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*
                                    Power(shs,4)))/
    (221184.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*Power(-1 + x,2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
     ) ;
    
    term[9] = - (Power(alpha,4)*beta1*Sqrt((1 - Power(beta1,2))*(1 - Power(beta2,2)))*(gL - gR)*(gL + gR)*
                 (-Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(phi)*
                 (Power(gqR,4)*Power(1 + hs,4)*
                  (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)*
                  (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs) + 
                  Power(gqL,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*
                  (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                   (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,4))
                 )/(1.572864e6*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
                    (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*s*(1 - Power(x,2))*
                    Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
                    Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
                    ); 
    
    term[10] = - (Power(alpha,4)*beta1*Sqrt((1 - Power(beta1,2))*(1 - Power(beta2,2)))*(gL - gR)*(gL + gR)*
                  (-Power(gL,2) + Power(gR,2))*Power(M1,2)*Power(M2,2)*(1 + x)*Cos(phi)*
                  (Power(gqL,4)*Power(1 + hs,4)*
                   (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                    (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs)*
                   (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                    (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs) + 
                   Power(gqR,4)*(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                 (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs)*
                   (2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                    (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs)*Power(shs,4))
                  )/(1.572864e6*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
                     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*s*(1 - Power(x,2))*
                     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
                     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
                     ) ;
    
    term[11] =  (Power(alpha,4)*beta1*(1 - Power(beta2,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
                 Power(M2,2)*(Power(gqR,4)*Power(1 + hs,4)*
                              Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                    (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + 
                              Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                                 (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*
                              Power(shs,4)))/
    (221184.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*(1 + x)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
     ) ;
    
    term[12] =  (Power(alpha,4)*beta1*(1 - Power(beta2,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
                 Power(M2,2)*(Power(gqL,4)*Power(1 + hs,4)*
                              Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                    (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + 
                              Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                                 (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*
                              Power(shs,4)))/
    (221184.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*(1 + x)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
     ) ;
    
    term[13] =  (Power(alpha,4)*beta1*(Power(gqL,4) + Power(gqR,4))*Power(Power(gL,2) + Power(gR,2),2)*
                 Power(M1,2)*Power(M2,2)*(1 + x)*Power((beta1 + beta2 - beta1*x + beta2*x)*
                                                       Sqrt(beta1*beta2*(1 - Power(x,2))) + (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)),2)*
                 Power(shsdb,2))/
    (27648.*(-1 + Power(beta1,2))*(-1 + Power(beta2,2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Power(Pi,2)*s*
     Power(-1 + Power(x,2),2)*Power(-1 + xW,4)*Power(xW,4)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
     );
    
    double returnVal = 0.; 
    for (int i = 0; i < nterms; i++){
        //std::cout << "term[" << i << "] = " << term[i] << std::endl;
        if (term[i] != term[i]) { 
            //std::cout << "isNaN" << std::endl; 
            term[i] = 0.; 
        }
        returnVal += term[i];
    }
    
    if (returnVal <= 0) returnVal = 1.e-40;
    return returnVal;
    
}
Double_t RooqqZZ_JHU::integratePartonicXS_Dh1Dh2DphDPh1_5(double m1_c, double m2_c, double h1_c, double h2_c, double phi_c, double hs_c, double Phi1_c, double mZZ_c, bool upType, bool flipAxis) const
{
    // define hs, h1, h2, phi1, phi2 for the NW angular conventions
    double s = mZZ_c*mZZ_c;
    double M1 = m1_c;
    double M2 = m2_c;
    double hs = hs_c;
    //double h1 = h1_c;
    //double h2 = h2_c;
    //double phi = phi_c;  NOT USED
    double Phi1 = Phi1_c;
    
    if (flipAxis){
        hs *= -1.;
        Phi1 += TMath::Pi();
        //phi += 0;
    }
    
    // extra definitions needed
    double shs = Sqrt(1-hs*hs); // sin Theta
    //double sh1 = Sqrt(1-h1*h1); // sin theta1
    //double sh2 = Sqrt(1-h2*h2); // sin theta2
    //double hsdb = 1 - 2*shs*shs; // cos 2*Theta NOT USED!!
    double shsdb = 2*hs*shs; // sin 2*Theta
    //double h1db = 1 - 2*sh1*sh1; // cos 2*theta1 NOT USED!!
    //double h2db = 1 - 2*sh2*sh2; // cos 2*theta2  NOT USED!!
    
    double x = (M1*M1-M2*M2)/s;
    double beta1 = Sqrt(1. - (4.*M1*M1)/(s*(1+x)*(1+x))); 
    double beta2 = Sqrt(1. - (4.*M2*M2)/(s*(1+x)*(1+x)));
    double MZ = 91.18; // mass of the Z
    double gamma = 2.475; // width of the Z
    double xW = 0.2312; // sin2thetaW
    double Pi = TMath::Pi();
    double alpha = 1./137; // EM constant
    
    double Tf3 = -1/2.; double Qf = -1.;
    double gL = 2.*(Tf3 - xW*Qf), gR = -2.*xW*Qf;
    
    double qTf3, qQf;
    if (upType){
        qTf3 = 1/2.; qQf = 2./3.;
    }
    else{
        qTf3 = -1/2.; qQf = -1./3.;
    }
    double gqL = 2.*(qTf3 - xW*qQf), gqR = -2.*xW*qQf;
    
    
    const int nterms = 9;
    double term[nterms];
    
    ////////////////////////////
    term[0] = (Power(alpha,4)*beta1*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*(1 + x)*
     (Power(gqR,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + 
      Power(gqL,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*Power(shs,2))/
    (13824.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                       4*beta1*beta2*Power(shs,2),2)) ;
    
    term[1] = (Power(alpha,4)*beta1*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*(1 + x)*
     (Power(gqL,4)*Power(x + beta1*beta2*x + hs - beta1*beta2*hs,2) + 
      Power(gqR,4)*Power(x + beta1*beta2*x + (-1 + beta1*beta2)*hs,2))*Power(shs,2))/
    (13824.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                       4*beta1*beta2*Power(shs,2),2)) ;
    
    term[2] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
     Power(M2,2)*(1 + x)*Power(shs,2)*
     (Power(gqR,4)*Power(1 + hs,4) + Power(gqL,4)*Power(shs,4)))/
    (13824.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[3] = (Power(alpha,4)*beta1*Power(1 + beta1*beta2,2)*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
     Power(M2,2)*(1 + x)*Power(shs,2)*
     (Power(gqL,4)*Power(1 + hs,4) + Power(gqR,4)*Power(shs,4)))/
    (13824.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)); 
    
    term[4] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*
     (1 + x)*(Power(gqR,4)*Power(1 + hs,4)*
              Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                    (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + 
              Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                 (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*
              Power(shs,4)))/
    (110592.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + x,2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
     ) ;
    
    term[5] = (Power(alpha,4)*beta1*(1 - Power(beta1,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
          Power(M2,2)*(1 + x)*(Power(gqL,4)*Power(1 + hs,4)*
                               Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                     (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(-1 + x)*hs,2) + 
                               Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                                  (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(-1 + x)*hs,2)*
                               Power(shs,4)))/
    (110592.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + x,2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(1 + hs,2)*
     Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 4*beta1*beta2*Power(shs,2),2)
     ) ;
    
    term[6] = (Power(alpha,4)*beta1*(1 - Power(beta2,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
          Power(M2,2)*(Power(gqR,4)*Power(1 + hs,4)*
                       Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                             (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + 
                       Power(gqL,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                                          (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*
                       Power(shs,4)))/
    (110592.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(1 + x)*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[7] = (Power(alpha,4)*beta1*(1 - Power(beta2,2))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*Power(M2,2)*
     (Power(gqL,4)*Power(1 + hs,4)*
      Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
            (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) - 4*(1 + x)*hs,2) + 
      Power(gqR,4)*Power(2 + Power(beta1,2) + Power(beta2,2) + 2*(Power(beta1,2) - Power(beta2,2))*x + 
                         (-2 + Power(beta1,2) + Power(beta2,2))*Power(x,2) + 4*(1 + x)*hs,2)*
      Power(shs,4)))/
    (110592.*(Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*(1 + x)*Power(-1 + xW,4)*
     Power(xW,4)*Power(1 + hs,2)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                               4*beta1*beta2*Power(shs,2),2)) ;
    
    term[8] = (Power(alpha,4)*beta1*(Power(gqL,4) + Power(gqR,4))*Power(Power(gL,2) + Power(gR,2),2)*Power(M1,2)*
     Power(M2,2)*(1 + x)*Power((beta1 + beta2 - beta1*x + beta2*x)*Sqrt(beta1*beta2*(1 - Power(x,2))) + 
                               (1 + Power(beta1,2)*Power(beta2,2))*(-1 + Power(x,2)),2)*Power(shsdb,2))/
    (13824.*(-1 + Power(beta1,2))*(-1 + Power(beta2,2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M1,2) - Power(MZ,2),2))*
     (Power(gamma,2)*Power(MZ,2) + Power(Power(M2,2) - Power(MZ,2),2))*Pi*s*Power(-1 + Power(x,2),2)*
     Power(-1 + xW,4)*Power(xW,4)*Power(Power(-1 + beta1*beta2,2) - Power(x + beta1*beta2*x,2) + 
                                        4*beta1*beta2*Power(shs,2),2));
    
    double returnVal = 0.; 
    for (int i = 0; i < nterms; i++){
        //std::cout << "term[" << i << "] = " << term[i] << std::endl;
        if (term[i] != term[i]) { 
            //std::cout << "isNaN" << std::endl; 
            term[i] = 0.; 
        }
        returnVal += term[i];
    }
    
    if (returnVal <= 0) returnVal = 1.e-40;
    return returnVal;
    
}
