*********************************************************
*AUTHOR: FABIO MALTONI                                  *
*DATE  : 10/10/2001                                     *
*NOTES : PROGRAM GENERATED BY BHIGGS.M                  *
*********************************************************

      DOUBLE PRECISION FUNCTION  BBBBH(I1,I2,I3,I4)
* ---------------------------------------------------------------------
* returns the matrix element squared for the process
*
*          0 -> bbar1 b2 bbar3 b4 h
*
* All momenta outgoing.
* No averaging is performed for initial spins or colors.
* No symmetry factors are included.
* No STRONG coupling is included.
* No Bottom-Higgs coupling is included.
* ---------------------------------------------------------------------

      IMPLICIT NONE
      INCLUDE 'constants.f'
      include 'sprods_com.f'
      include 'zprods_com.f'

*     ARGUMENTS
      INTEGER I1,I2,I3,I4

*     LOCAL
      DOUBLE PRECISION  T123,T124,T134,T234
      DOUBLE COMPLEX AMP(2,4)
      INTEGER L


      t123=s(i1,i2)+s(i2,i3)+s(i1,i3)
      t124=s(i1,i2)+s(i2,i4)+s(i1,i4)
      t134=s(i1,i3)+s(i1,i4)+s(i3,i4)
      t234=s(i2,i3)+s(i2,i4)+s(i3,i4)

      amp(1,1)=
     .   (-2d0*(za(i4,i2)*zb(i2,i1) + za(i4,i3)*zb(i3,i1))*zb(i3,i2))/
     -   (T234*s(i3,i4)) + (2d0*zb(i3,i1)*
     -     (za(i4,i1)*zb(i2,i1) - za(i4,i3)*zb(i3,i2)))/
     -   (T134*s(i3,i4))

      amp(2,1)=
     .   (-2d0*zb(i1,i2)*(za(i4,i1)*zb(i1,i3) + za(i4,i2)*zb(i2,i3)))/
     -   (T124*s(i1,i4)) + (2d0*zb(i1,i3)*
     -     (-(za(i4,i1)*zb(i1,i2)) + za(i4,i3)*zb(i2,i3)))/
     -   (T134*s(i1,i4))

      amp(1,2)=
     .   (-2d0*(za(i3,i2)*zb(i2,i1) + za(i3,i4)*zb(i4,i1))*zb(i4,i2))/
     -   (T234*s(i3,i4)) + (2d0*zb(i1,i4)*
     -     (za(i1,i3)*zb(i2,i1) - za(i4,i3)*zb(i4,i2)))/
     -   (T134*s(i3,i4))

      amp(2,2)=
     .        (2d0*zb(i1,i2)*(-(za(i2,i3)*zb(i2,i4)) +
     -       za(i1,i3)*zb(i4,i1)))/(T123*s(i2,i3)) -
     -  (2d0*zb(i2,i4)*(za(i3,i2)*zb(i2,i1) + za(i3,i4)*zb(i4,i1)))/
     -   (T234*s(i2,i3))

      amp(1,3)=
     .    (2d0*zb(i1,i4)*(za(i2,i1)*zb(i3,i1) - za(i2,i4)*zb(i4,i3)))/
     -   (T124*s(i1,i2)) + (2d0*
     -     (za(i2,i1)*zb(i1,i3)*zb(i4,i1) +
     -       za(i3,i2)*zb(i3,i1)*zb(i4,i3)))/(T123*s(i1,i2))

      amp(2,3)=
     .   (2d0*zb(i3,i4)*(za(i2,i3)*zb(i1,i3) - za(i2,i4)*zb(i4,i1)))/
     -   (T234*s(i2,i3)) + (2d0*
     -     (za(i1,i2)*zb(i1,i3)*zb(i4,i1) +
     -       za(i2,i3)*zb(i3,i1)*zb(i4,i3)))/(T123*s(i2,i3))

      amp(1,4)=
     .   (2d0*zb(i3,i2)*(za(i2,i1)*zb(i4,i2) + za(i3,i1)*zb(i4,i3)))/
     -   (T123*s(i1,i2)) + (2d0*zb(i4,i2)*
     -     (za(i2,i1)*zb(i3,i2) - za(i4,i1)*zb(i4,i3)))/
     -   (T124*s(i1,i2))

      amp(2,4)=
     .   (2d0*(za(i3,i1)*zb(i2,i3) + za(i4,i1)*zb(i2,i4))*zb(i3,i4))/
     -   (T134*s(i1,i4)) + (2d0*zb(i2,i4)*
     -     (-(za(i2,i1)*zb(i2,i3)) + za(i4,i1)*zb(i3,i4)))/
     -   (T124*s(i1,i4))




      BBBBH=0d0
      do l=1,4
      BBBBH=BBBBH+cdabs(amp(1,l))**2+cdabs(amp(2,l))**2
     .     +2d0/xn*dble(amp(1,l)*dconjg(amp(2,l)))
      enddo


      BBBBH=2D0*BBBBH*V/4d0

      END
